# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "kube-cel"
version = "0.4.0"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Kubernetes CEL extension functions for the cel crate"
documentation = "https://docs.rs/kube-cel"
readme = "README.md"
keywords = [
    "kubernetes",
    "cel",
    "kube",
    "validation",
]
categories = ["api-bindings"]
license = "Apache-2.0"
repository = "https://github.com/doxxx93/kube-cel"

[features]
default = [
    "strings",
    "lists",
    "sets",
    "regex_funcs",
    "urls",
    "ip",
    "semver_funcs",
    "format",
    "quantity",
    "jsonpatch",
    "named_format",
    "math",
    "encoders",
]
encoders = ["dep:base64"]
format = []
ip = ["dep:ipnet"]
jsonpatch = []
lists = []
math = []
named_format = []
quantity = []
regex_funcs = ["dep:regex"]
semver_funcs = ["dep:semver"]
sets = []
strings = []
urls = ["dep:url"]
validation = [
    "dep:serde_json",
    "dep:serde",
    "dep:chrono",
]

[lib]
name = "kube_cel"
path = "src/lib.rs"

[[example]]
name = "basic"
path = "examples/basic.rs"

[[example]]
name = "compiled_schema"
path = "examples/compiled_schema.rs"
required-features = ["validation"]

[[example]]
name = "timestamp_duration"
path = "examples/timestamp_duration.rs"
required-features = ["validation"]

[[example]]
name = "validate_crd"
path = "examples/validate_crd.rs"
required-features = ["validation"]

[[test]]
name = "compilation_integration"
path = "tests/compilation_integration.rs"

[[test]]
name = "validation_integration"
path = "tests/validation_integration.rs"

[[test]]
name = "validation_spike"
path = "tests/validation_spike.rs"

[dependencies.base64]
version = "0.22"
optional = true

[dependencies.cel]
version = "0.12"

[dependencies.chrono]
version = "0.4"
features = ["alloc"]
optional = true
default-features = false

[dependencies.ipnet]
version = "2"
optional = true

[dependencies.regex]
version = "1"
optional = true

[dependencies.semver]
version = "1"
optional = true

[dependencies.serde]
version = "1"
features = ["derive"]
optional = true

[dependencies.serde_json]
version = "1"
optional = true

[dependencies.url]
version = "2"
optional = true

[lints.rust]
unsafe_code = "forbid"
